jQuery(document).ready(function(jQuery){

    //jQuery('#_sku').prop('required', true);

    jQuery( '#publish, .save-variation-changes' ).on( 'click', function() {

        if(jQuery('#post_type').val() == 'product') {

            var title = jQuery.trim(jQuery('#title').val());

            if ( title == '' ) {
                alert( mf_sync_script_vars.title_required );
                jQuery( '#title' ).focus();
                return false;
            }

            var regular_price = jQuery.trim(jQuery('#_regular_price').val());
            var product_type = jQuery('#product-type').val();

            //Todo: Validate bookable product
            //Todo: Validate the quick edit
            if ( (product_type != 'booking' && product_type != 'variable') && (regular_price == '' || regular_price == 0)  ) {
                alert( mf_sync_script_vars.regular_price_required );

                jQuery( '.general_tab > a' ).click();
                jQuery( '#_regular_price' ).focus();
                return false;
            }


            var sku = jQuery.trim(jQuery('#_sku').val());

            if ( product_type != 'variable' && (sku == '' || sku == 0)  ) {
                alert( mf_sync_script_vars.sku_required );

                jQuery( '.inventory_tab > a' ).click();
                jQuery( '#_sku' ).focus();
                return false;
            }

            var mf_account_code = jQuery.trim(jQuery('#mf_account_code').val());

            if ( mf_account_code == '' || mf_account_code == 0  ) {
                alert( mf_sync_script_vars.account_code_required );

                jQuery( '.mf_tab_tab > a' ).click();
                jQuery( '#mf_account_code' ).focus();
                return false;
            }

            if(product_type == 'variable') {

                var valid = true;

                var variants_sku = jQuery("input[name*='variable_sku']");
                if(variants_sku.length) {
                    variants_sku.each(function(){
                        if(jQuery.trim(jQuery(this).val()) == '') {
                            valid = false;
                        }
                    });
                }

                var variants_price = jQuery("input[name*='variable_regular_price']");
                if(variants_price.length) {
                    variants_price.each(function(){
                        if(jQuery.trim(jQuery(this).val()) == '') {
                            valid = false;
                        }
                    });
                }

                if(!valid) {
                    alert( mf_sync_script_vars.variants_sku_price_required );
                    jQuery( '.variations_tab > a' ).click();
                }

                return valid;
            }
        }

    });

    mf_sync();
});



function mf_sync() {
    var total = null,
        page = 0,
        page_size = mf_sync_script_vars.mf_sync_items_per_page,
        total_pages = 0,
        btn_reactivate_cron = jQuery('#mf_btn_reactivate_cron'),
        btn_force_sync = jQuery("#mf_sync_now"),
        textareaStatus = jQuery("#mf_sync_status"),
        nonce = btn_force_sync.data("nonce");

    //Events
    btn_force_sync.click(startSync);
    btn_reactivate_cron.click(mf_ajax_reactivate_cron);

    function startSync(e) {
        e.preventDefault();
        toggleButton(0);
        textareaStatus.show();
        mf_ajax_tax_rule();
    }

    function mf_ajax_reactivate_cron(e) {
        e.preventDefault();
        textareaStatus.show();
        textareaStatus.append('Start cron' + "\n");

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_ajax_reactivate_cron", security: nonce},
            success: function(response) {
                if (response.success === true) {
                    textareaStatus.append('Cron OK' + "\n");
                } else {
                    textareaStatus.append(response.data + "\n");
                }
            }
        });
    }

    function mf_ajax_groups() {
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_ajax_groups", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                if(response && response.total) {
                    total_pages = Math.ceil(response.total / page_size);

                    if(total_pages > (page+1)) {
                        page++;
                        mf_ajax_groups();
                    } else {
                        page = 0;
                        mf_ajax_clean_groups();
                    }
                }
            }
        });
    }

    function mf_ajax_clean_groups() {
        //Todo: Disable the button
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_ajax_clean_groups", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                if(response) {
                    mf_ajax_campaigns();
                }
            }
        });
    }

    function mf_ajax_campaigns() {
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_ajax_campaigns", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                if(response && response.total) {
                    total_pages = Math.ceil(response.total / page_size);

                    if(total_pages > (page+1)) {
                        page++;
                        mf_ajax_campaigns();
                    } else {
                        page = 0;
                        mf_ajax_clean_campaigns();
                    }
                }
            }
        });
    }

    function mf_ajax_clean_campaigns() {
        //Todo: Disable the button
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_ajax_clean_campaigns", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                if(response) {
                    campaigns_article_sets();
                }
            }
        });
    }

    function campaigns_article_sets() {
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_ajax_campaigns_article_sets", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                if(response && response.total) {
                    total_pages = Math.ceil(response.total / page_size);

                    if(total_pages > (page+1)) {
                        page++;
                        campaigns_article_sets();
                    } else {
                        page = 0;
                        bookkeeping();
                    }
                }
            }
        });
    }

    function bookkeeping() {
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_ajax_bookkeeping", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                if(response && response.total) {
                    total_pages = Math.ceil(response.total / page_size);

                    if(total_pages > (page+1)) {
                        page++;
                        bookkeeping();
                    } else {
                        page = 0;
                        mf_ajax();
                    }
                }
            }
        });
    }

    function mf_ajax() {
        //Todo: Disable the button
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_sync", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                //This is the first request's response
                if(response && total === null) {
                    onFirstRequestSuccess(response);
                } else {
                    onOtherRequestSuccess(response)
                }
            }
        });
    }

    function mf_ajax_tax_rule() {
        //Todo: Disable the button
        updateStatus('started');

        jQuery.ajax({
            type : "post",
            dataType : "json",
            timeout: 300000,
            url : mf_sync_script_vars.ajax_url,
            data : {action: "mf_tax_sync", security: nonce, page: page, page_size: page_size},
            success: function(response) {
                if(response) {
                    mf_ajax_groups();
                }
            }
        });
    }    

    function onFirstRequestSuccess(response) {
        if(response && response.total) {
            total = response.total;
            total_pages = Math.ceil(response.total / page_size);

            updateStatus('completed');

            if(total_pages > 0) {
                page++;
                mf_ajax();
            } else {
                //toggleButton(1);
            }
        } else {
            //ToDo: Handle the error
        }
    }

    function onOtherRequestSuccess(response) {
        if(response && response.total) {
            //total = response.total;
            //total_pages = Math.ceil(response.total / page_size);
            updateStatus('completed');

            if(total_pages > page) {
                page++;
                mf_ajax();
            } else {
                alert(mf_sync_script_vars.sync_completed);
            }
        } else {
            //ToDo: Handle the error
        }
    }

    function updateStatus(action){
        var message = '';

        if(action == 'started') {
            message += mf_sync_script_vars.sync_starting_to_process_page;
        } else if(action == 'completed') {
            message += mf_sync_script_vars.sync_completed_processing_page;
        }

        if(total === null) {
            message += ' ' + (page + 1);
        } else {
            message += ' ' + (page + 1) + '/' + (total_pages + 1);
        }

        textareaStatus.append(message + "\n");

        textareaStatus.animate({
            scrollTop:textareaStatus[0].scrollHeight - textareaStatus.height()
        },10);
    }

    function toggleButton(state) {
        if (state) {
            btn_force_sync.removeAttr('disabled');
        } else {
            btn_force_sync.attr('disabled', 'disabled');
        }
    }

}

