<?php
class MfWcProductTab
{
    public function __construct()
    {
        add_filter('woocommerce_product_data_tabs', array(&$this, 'register_tabs'));
        add_action('admin_head', array(&$this, 'mf_styles'));
    }

    function register_tabs($default_tabs)
    {
        $custom_product_tab['mf_tab'] = array(
            LABEL => __('Moreflo', 'wpmf'),
            'target' => 'mf_tab',
            'class' => array()
        );

        $insert_at_position = 7;
        $tabs = array_slice($default_tabs, 0, $insert_at_position, true);
        $tabs = array_merge($tabs, $custom_product_tab);
        $tabs = array_merge($tabs, array_slice($default_tabs, $insert_at_position, null, true));

	    $tabs['inventory']['class'][] = 'show_if_booking';

        return $tabs;
    }

    function mf_styles()
    {
?>
        <style>
        #woocommerce-product-data ul.wc-tabs li.mf_tab_options.mf_tab_tab a:before {
            background: url(<?php echo plugin_dir_url(__FILE__) . 'img/mf_tab.svg' ?>) center center no-repeat;
            content: " " !important;
            background-size: 100%;
            width: 13px;
            height: 13px;
            display: inline-block;
            line-height: 1;
        }
        </style>
<?php
    }
}

$MfWcProductTab = new MfWcProductTab();


