<?php
class MfWcProductTabContent {

    public function __construct()
    {
        add_action('woocommerce_product_data_panels', array(&$this, 'add_custom_product_meta'));
        add_action('woocommerce_process_product_meta', array(&$this, 'save_custom_product_meta'));
        add_action('woocommerce_variation_options_pricing', array(&$this, 'add_variation_custom_product_meta'), 10, 3);
    }

    function add_custom_product_meta()
    {
        global $post;
	    $product_type = WC_Product_Factory::get_product_type($post->ID);

?>
        <div id='mf_tab' class='panel woocommerce_options_panel'>
            <div class='options_group'>
                <?php

                $args =  array(
	                ID          => MF_ACCOUNT_CODE,
	                LABEL       => __( 'MoreFlo Account Code', 'wpmf' ),
	                DESCRIPTION => __( 'Choose a value.', 'wpmf' ),
	                VALUE       => get_post_meta( $post->ID, MF_ACCOUNT_CODE, true ),
	                'options' => mf_get_account_codes()
                );
                woocommerce_wp_select($args);

                if($product_type != VARIABLE) {
                    $args = array(
                        LABEL             => __( 'MoreFlo Sync Status', 'wpmf' ),
                        PLACEHOLDER       => __( 'Not synced', 'wpmf' ),
                        ID                => MF_SYNC_STATUS,
                        DESC_ENABLE          => true,
                        CUSTOM_ATTRIBUTES => array( 'readonly' => 'readonly' ),
                        DESCRIPTION       => __( 'Sync status with MoreFlo Apps.', 'wpmf' ),
                    );
                    woocommerce_wp_text_input( $args );

                    $args = array(
                        LABEL             => __( 'MoreFlo Sync Data', 'wpmf' ),
                        PLACEHOLDER       => __( 'No sync data available', 'wpmf' ),
                        ID                => 'mf_last_sync_response',
                        DESC_ENABLE          => true,
                        CUSTOM_ATTRIBUTES => array( 'readonly' => 'readonly' ),
                        DESCRIPTION       => __( 'Last sync data from MoreFlo.', 'wpmf' ),
                    );
                    woocommerce_wp_textarea_input( $args );
                }
                ?>
            </div>
        </div>
        <?php
    }

    function save_custom_product_meta($post_id)
    {
        $mf_account_code = isset($_POST[MF_ACCOUNT_CODE]) ? sanitize_text_field($_POST[MF_ACCOUNT_CODE]) : '';
        update_post_meta($post_id, MF_ACCOUNT_CODE, $mf_account_code);
    }



	function add_variation_custom_product_meta( $loop, $variation_data, $variation ) {
		woocommerce_wp_text_input( array(
				ID => 'mf_sync_status[' . $loop . ']',
				'class' => 'short',
				LABEL => __('Moreflo Sync Status', 'wpmf'),
				CUSTOM_ATTRIBUTES => array('readonly' => 'readonly'),
				VALUE => get_post_meta( $variation->ID, MF_SYNC_STATUS, true )
			)
		);

		woocommerce_wp_textarea_input( array(
				ID => 'mf_last_sync_response[' . $loop . ']',
				'class' => 'short',
				LABEL => __('Moreflo Sync Data', 'wpmf'),
				PLACEHOLDER => __('No sync data available', 'wpmf'),
				DESCRIPTION => __('Last sync data from Moreflo.', 'wpmf'),
				DESC_ENABLE => true,
				CUSTOM_ATTRIBUTES => array('readonly' => 'readonly', 'cols' => 20, 'rows' => 2),
				VALUE => get_post_meta( $variation->ID, 'mf_last_sync_response', true )
			)
		);
	}

}

$MfWcProductTabContent = new MfWcProductTabContent();


