<?php

class MfLog
{
	/**
	 * Add a log entry.
	 *
	 * @param string $level One of the following:
	 *     'emergency': System is unusable.
	 *     'alert': Action must be taken immediately.
	 *     'critical': Critical conditions.
	 *     'error': Error conditions.
	 *     'warning': Warning conditions.
	 *     'notice': Normal but significant condition.
	 *     'info': Informational messages.
	 *     'debug': Debug-level messages.
	 * @param string $message Log message.
	 */

    static function log($level, $message)
    {
        $moreflo_settings = get_option(MOREFLO_API_URL);

        if (isset($moreflo_settings['log_enabled']) && $moreflo_settings['log_enabled'] == "checked") {

        	if(is_array($message)) {
		        $message = serialize($message);
	        }
	        if(is_object($message)) {
		        $message = serialize($message);
	        }

	        if(function_exists('wc_get_logger')) {
		        $MfLogger = wc_get_logger();
		        $MfLogger->log($level, $message, array('source' => 'moreflo-sync'));
	        }
        }


    }
}


