<?php

defined( 'ABSPATH' ) || exit;

class MF_Sync_Bookkeeping {
    private const OPTION_VAT_BASE = 'mf_sync_vat_';

    /**
     * Sets Vat account of a specific rate
     * 
     * @param int $vat_rate 0, 6, 12, 25
     * @param int $account Account number
     */
    public static function set_vat_account( $vat_rate, $account ) {
        $option_name = self::get_vat_option_name( $vat_rate );
        update_option( $option_name, $account );
    }

    /**
     * Gets the vat account for the given rate
     * 
     * @param int $vat_rate 0, 6, 12, 25
     * @return int|bool Account number, false on not set
     */
    public static function get_vat_account( $vat_rate ) {
        $option_name = self::get_vat_option_name( $vat_rate );
        return get_option( $option_name );
    }

    private static function get_vat_option_name( $vat_rate ) {
        return self::OPTION_VAT_BASE . $vat_rate;
    }
}
