<?php

defined( 'ABSPATH' ) || exit;

add_action( 'plugins_loaded', 'moreflo_sync_campaigns_setup' );

/**
 * Responsible for activaing campaigns
 */
function moreflo_sync_campaigns_setup() {
    // Check that WooCommerce is activated
    if ( ! function_exists( 'WC' ) ) {
        return;
    }

    // Include required files
    require_once('models/interface-discounter.php');

    require_once('models/model-product.php');
    require_once('models/model-discounter-type-0.php');
    require_once('models/model-discounter-type-1.php');
    require_once('models/model-discounter-type-2.php');
    require_once('models/model-discounter-type-3.php');
    require_once('models/model-discounter-type-4.php');
    require_once('models/model-discounter-type-5.php');
    require_once('models/model-discounter-type-set.php');

    require_once('factory.php');
    require_once('campaigns.php');
    require_once('sync.php');
    require_once('sync-sets.php');
}

/**
 * Checks if campaigns are enabled
 */
function moreflo_sync_campaigns_enabled() {
    $api_options = get_option(MOREFLO_API_URL);
    return isset( $api_options['is_campaigns_active'] )
        && 'enabled' == $api_options['is_campaigns_active'];
}
