<?php

defined( 'ABSPATH' ) || exit;

interface MF_Campaigns_Discounter {
    /**
     * Gets the discounter display name
     * 
     * @return string
     */
    public function get_name();

    /**
     * Get the WooCommerce coupon.
     * 
     * @return WC_Coupon
     */
    public function get_coupon();

    /**
     * Get the priority.
     * 
     * @return int
     */
    public function get_priority();

    /**
     * Checks if this discount is applicable for these products.
     * 
     * @param float $cart_total Cart total inc VAT.
     * @param MF_Campaigns_Product[] $products
     * @return bool
     */
    public function is_applicable( $cart_total, $products );

    /**
     * Get the products with discounts.
     * 
     * @param MF_Campaigns_Product[] $products Prices must be inc VAT.
     * @param int $cart_total Cart total inc VAT.
     * @return MF_Campaigns_Product[] Updated list of products with discounts, inc VAT.
     */
    public function get_discounted_products( $products, $cart_total );
}
