<?php

defined( 'ABSPATH' ) || exit;

class MF_Campaigns_Product {
    /**
     * @param string $name
     * @param string $sku
     * @param float $price Price inc VAT
     * @param int $vat_rate
     */
    public function __construct( $name, $sku, $price, $vat_rate ) {
        $this->set_name( $name );
        $this->set_sku( $sku );
        $this->set_price( $price );
        $this->vat_rate = $vat_rate;
    }

    /** @return string */
    public function get_name() { return $this->name; }
    /** @param string $name */
    public function set_name( $name ) { $this->name = $name; }

    /** @return string */
    public function get_sku() { return $this->sku; }
    /** @param string $sku */
    public function set_sku( $sku ) { $this->sku = $sku; }

    /** @return float */
    public function get_price() { return $this->price; }
    /** @param float $price */
    public function set_price( $price ) { $this->price = floatval( $price ); }

    /**
     * Gets discount
     * 
     * @param bool $remove_vat Set this to true to remove vat of discount. Used if prices are ex tax in Woo.
     * @return float
     */
    public function get_discount( $remove_vat = false ) {
        return $remove_vat
            ? $this->discount / ( 1 + ( $this->vat_rate / 100.0 ) )
            : $this->discount;
    }
    /** @param float $discount */
    public function set_discount( $discount ) { $this->discount = floatval( $discount ); }

    /** @return int */
    public function get_uses() { return $this->uses; }
    /** Adds a use to this product */
    public function add_use() { $this->uses++; }

    /** @var string */
    protected $name;
    /** @var string */
    protected $sku;
    /** @var float */
    protected $price = 0.0;
    /** @var float */
    protected $discount = 0.0;
    /** @var int */
    protected $vat_rate;
    /** @var int */
    protected $uses = 0;
}
