<?php

defined( 'ABSPATH' ) || exit;

add_action( 'plugins_loaded', 'moreflo_sync_groups_setup' );

/**
 * Responsible for activaing group sync
 */
function moreflo_sync_groups_setup() {
    // Check that WooCommerce is activated
    if ( ! function_exists( 'WC' ) ) {
        return;
    }

    // Include required files
    require_once('sync.php');
}

/**
 * Checks if groups are enabled
 */
function moreflo_sync_groups_enabled() {
    $api_options = get_option(MOREFLO_API_URL);
    return isset( $api_options['is_product_categories_active'] )
        && 'enabled' == $api_options['is_product_categories_active'];
}
