<?php

defined( 'ABSPATH' ) || exit;

add_action( 'plugins_loaded', 'moreflo_sync_receipts_setup' );

/**
 * Responsible for activating receipts
 */
function moreflo_sync_receipts_setup() {
    // Check that WooCommerce is activated
    if ( ! function_exists( 'WC' ) ) {
        return;
    }

    // Include required files
    require_once( 'models/base.php' );
    require_once( 'models/model-account-code.php' );
    require_once( 'models/model-article.php' );
    require_once( 'models/model-customer.php' );
    require_once( 'models/model-order-reference.php' );
    require_once( 'models/model-merchant.php' );
    require_once( 'models/model-payment.php' );
    require_once( 'models/model-receipt-discount.php' );
    require_once( 'models/model-receipt.php' );
    require_once( 'models/model-vat.php' );
    require_once( 'models/model-voucher.php' );
    require_once( 'models/model-voucher-row.php' );

    require_once( 'factory.php' );
    require_once( 'helper.php' );
    require_once( 'receipts.php' );
}

/**
 * Checks if receipts are enabled
 */
function moreflo_sync_receipts_enabled() {
    $api_options = get_option(MOREFLO_API_URL);
    return isset( $api_options['is_receipt_active'] )
        && 'enabled' == $api_options['is_receipt_active'];
}
