<?php

class MF_Sync_Model_Receipt extends MF_Sync_Receipts_Model implements JsonSerializable {
    /** @var int */
    protected $ReceiptNumber = 0;
    /** @var string */
    protected $Origin = '';
    /** @var string */
    protected $Id = null;
    /** @var string */
    protected $ReceiptType = '';
    /** @var string */
    protected $InternalNote = '';
    /** @var string */
    protected $TransactionDate;
    /** @var string */
    protected $CashierName = null; // Den som tar ut kvittot och ger till kunden, finns ingen sådan i Woo
    /** @var int */
    protected $TotalPriceIncVat = 0;
    /** @var int */
    protected $TotalPriceExVat = 0;
    /** @var int */
    protected $TotalVat = 0;
    /** @var bool */
    protected $DoStockMgmt = true;
    /** @var MF_Sync_Model_Merchant[] */
    protected $Merchant;
    /** @var int[] */
    protected $Rounding = null;
    /** @var string[] */
    protected $ControlUnit = null;
    /** @var MF_Sync_Model_Customer[] */
    protected $Customers = [];
    /** @var MF_Sync_Model_Article[] */
    protected $Articles = [];
    /** @var MF_Sync_Model_Payment[] */
    protected $Payments = [];
    /** @var MF_Sync_Model_Vat[] */
    protected $Vat = [];
    /** @var MF_Sync_Model_OrderReference[] */
    protected $Orders = [];
    /** @var MF_Sync_Model_Receipt_Discount[] */
    protected $Discounts = [];
    /** @var array */
    protected $Recipients = [];
    /** @var array|null */
    protected $TextRows = null;
    /** @var string[]|null */
    protected $ClientDetails = null;
    /** @var MF_Sync_Model_Voucher */
    protected $Voucher = null;

    public function get_voucher() {
        return $this->Voucher;
    }

    public function get_articles() {
        return $this->Articles;
    }

    public function jsonSerialize() {
        return [
            'ReceiptNumber' => $this->ReceiptNumber,
            'Origin' => $this->Origin,
            'Id' => $this->Id,
            'ReceiptType' => $this->ReceiptType,
            'InternalNote' => $this->InternalNote,
            'TransactionDate' => $this->TransactionDate,
            'CashierName' => $this->CashierName,
            'TotalPriceIncVat' => $this->TotalPriceIncVat,
            'TotalPriceExVat' => $this->TotalPriceExVat,
            'TotalVat' => $this->TotalVat,
            'DoStockMgmt' => $this->DoStockMgmt,
            'Merchant' => $this->Merchant,
            'Rounding' => $this->Rounding,
            'ControlUnit' => $this->ControlUnit,
            'Customers' => $this->Customers,
            'Articles' => $this->Articles,
            'Payments' => $this->Payments,
            'Vat' => $this->Vat,
            'Orders' => $this->Orders,
            'Discounts' => $this->Discounts,
            'Recipients' => $this->Recipients,
            'TextRows' => $this->TextRows,
            'ClientDetails' => $this->ClientDetails,
            'Voucher' => $this->Voucher,
        ];
    }
}
