<?php
/*
Plugin Name: MoreFlo Sync
Plugin URI: https://www.moreflo.com/
Description: WooCommerce Moreflo Sync.
Version: 2.8.12
Author: MoreFlo
Author URI: https://www.moreflo.com/
License: GPLv2  or later
Text Domain: wpmf
Domain Path: /languages/
*/

//get the file paths
define('PLUGIN_SLUG', 'wp_moreflo');
define('PLUGIN_UPGRADE_TRANS', 'moreflo_upgrade_wp_moreflo');
define('RESPONSE', 'response');
define('MOREFLOW_PLUGIN_DIR', plugin_dir_path(__FILE__));
define('SERVICE', 'service');
define('NORMAL', 'normal');
define('MF_HASH', 'mf_hash');
define('MF_ORDER_INFOR_HASH', 'mf_order_infor_hash');
define('MF_ORDER_TYPE', 'mf_order_type');
define('MF_ORDER_ID', 'mf_order_id');
define('MF_ACCOUNT_CODE', 'mf_account_code');
define('MF_SYNC_ARTICLES', 'mf_sync_articles');
define('MF_SYNC_ITEMS_PER_PAGE', 'mf_sync_items_per_page');
define('MF_SYNC_ARTICLES_INTERVAL', 'mf_sync_articles_interval');
define('MF_SYNC_STATUS', 'mf_sync_status');
define('MF_SYNC', 'mf_sync');
define('MF_SYNC_CRON_CHECK_EMAIL', 'mf_sync_cron_check_email_sent');
define('MOREFLO_API_URL', 'moreflo_api_url');
define('MF_ARTICLE_SYNC_LAST_UPDATED', 'mf_article_sync_last_updated');
define('DEBUG', 'debug');
define('ERROR', 'error');
define('INTERVAL', 'interval');
define('DISPLAY', 'display');
define('TOTAL', 'total');
define('ISWEBSHOPARTICLE', 'IsWebshopArticle');
define('ISACTIVEARTICLE', 'IsActiveArticle');
define('ISSTOCKITEM', 'IsStockItem');
define('ARTICLETYPE', 'ArticleType');
define('ARTICLENAME', 'ArticleName');
define('RETAILPRICE', 'RetailPrice');
define('ARTICLENUMBER', 'ArticleNumber');
define('ACCOUNTCODEID', 'AccountCodeId');
define('RECOMMENDEDPRICE', 'RecommendedPrice');
define('ISACTIVE', 'IsActive');
define('ISPRICEACTIVE', 'is_price_active');
define('QUANTITY', 'Quantity');
define('TYPEGOODS', 'Goods');
define('TYPESERVICE', 'Service');
define('BARCODE', 'Barcode');
define('UPDATEONEXISTING', 'UpdateOnExisting');
define('UNIT', 'Unit');
define('ID', 'id');
define('LABEL', 'label');
define('DESCRIPTION', 'description');
define('VALUE', 'value');
define('PLACEHOLDER', 'placeholder');
define('DESC_ENABLE', 'desc_tip');
define('CUSTOM_ATTRIBUTES', 'custom_attributes');
define('READONLY', 'readonly');
define('ARTICLES', 'articles');
define('APPOINTMENT', 'appointment');
define('BOOKING', 'booking');
define('VARIABLE', 'variable');
define('ARTICLEDRAFT', 'draft');
define('ARTICLEPUBLISH', 'publish');
if ( is_admin() ) {
require_once MOREFLOW_PLUGIN_DIR . 'class.moreflo-update.php';
}
//languages
add_action('plugins_loaded', 'mf_load_textdomain');

function mf_load_textdomain()
{
	load_plugin_textdomain('wpmf', false, dirname(plugin_basename(__FILE__)) . '/languages/');
}

//Api Calls
require_once MOREFLOW_PLUGIN_DIR . 'inc/class-moreflo-lock.php';
require_once MOREFLOW_PLUGIN_DIR . 'helpers/mf-helper.php';
require_once MOREFLOW_PLUGIN_DIR . 'helpers/class.moreflo-logger.php';

require_once MOREFLOW_PLUGIN_DIR . 'helpers/class.moreflo-api.php';

require_once MOREFLOW_PLUGIN_DIR . 'models/articles.php';
require_once MOREFLOW_PLUGIN_DIR . 'models/order.php';

//Options Pages
require_once MOREFLOW_PLUGIN_DIR . 'class.moreflo-admin.php';
require_once MOREFLOW_PLUGIN_DIR . 'class.moreflo-settings.php';

//Custom Fields
require_once MOREFLOW_PLUGIN_DIR . 'fields/class.mf_wc_product_tab.php';
require_once MOREFLOW_PLUGIN_DIR . 'fields/class.mf_wc_product_tab_content.php';

//Models


//Mappers
require_once MOREFLOW_PLUGIN_DIR . 'class.moreflo-mapper.php';

// Inc
require_once MOREFLOW_PLUGIN_DIR . 'inc/class-moreflo-admin-status.php';
require_once MOREFLOW_PLUGIN_DIR . 'inc/interface-sync.php';
require_once MOREFLOW_PLUGIN_DIR . 'inc/bookkeeping/index.php';
require_once MOREFLOW_PLUGIN_DIR . 'inc/receipts/index.php';
require_once MOREFLOW_PLUGIN_DIR . 'inc/groups/index.php';
require_once MOREFLOW_PLUGIN_DIR . 'inc/campaigns/index.php';
